\section{Possible singularities}

Before proceeding to the inverse kinematics problems, it is useful to identify beforehand the singularity points, that might cause problems in the calculations. In order to do this, the jacobian matrix between the zero reference frame and the end effector frame was calculated in \autoref{eqn:J} using \autoref{eqn:Jw} and \autoref{eqn:Jv} for rotational joints. The vectors ${}^0_iP$ and ${}^0_iz$ were extracted from the homogeneous transformation matrix between 0 and $i$, \autoref{eqn:T0i} as shown in \autoref{eqn:P0i} and \autoref{eqn:z0i}.


\begin{center}\begin{equation}
{}^0_6\mathbb{J}_\omega=[{}^0_1z, {}^0_2z, {}^0_3z, {}^0_4z, {}^0_5z, {}^0_6z]
\label{eqn:Jw}
\end{equation}\end{center}

\begin{center}\begin{equation}
{}^0_6\mathbb{J}_v=[{}^0_1z({}^0_6P-{}^0_1P), {}^0_2z({}^0_6P-{}^0_2P), {}^0_3z({}^0_6P-{}^0_3P), {}^0_4z({}^0_6P-{}^0_4P), {}^0_5z({}^0_6P-{}^0_5P), {}^0_6z({}^0_6P-{}^0_6P)]
\label{eqn:Jv}
\end{equation}\end{center}

\begin{center}\begin{equation}
{}^0_6\mathbb{J} =
[
{}^0_6\mathbb{J}_v, 
{}^0_6\mathbb{J}_\omega
]^T
\label{eqn:J}
\end{equation}\end{center}


\begin{doublespace}
\begin{center}\begin{equation}
{}^0_i\mathcal{T}_d=\left(
\begin{array}{cccc}
 {}^0_ir_{11} & {}^0_ir_{12} & {}^0_ir_{13} & {}^0_ip_x \\
 {}^0_ir_{21} & {}^0_ir_{22} & {}^0_ir_{23} & {}^0_ip_y \\
 {}^0_ir_{31} & {}^0_ir_{32} & {}^0_ir_{33} & {}^0_ip_z \\
 0 & 0 & 0 & 1 \\
\end{array}\right)
\label{eqn:T0i}\end{equation}\end{center}
\end{doublespace}

\begin{center}\begin{equation}
{}^0_iP = [{}^0_ip_x, {}^0_ip_y, {}^0_ip_z]^T
\label{eqn:P0i}
\end{equation}\end{center}

\begin{center}\begin{equation}
{}^0_iz = [{}^0_ir_13, {}^0_ir_23, {}^0_ir_33]^T
\label{eqn:z0i}
\end{equation}\end{center}

The singularities were identified by computing the determinant |${}^0_6\mathbb{J}$| = 0. The result is illustrated in \autoref{eqn:Sing}.
 
 \begin{center}\begin{equation}
-a_2 s_5 (a_3 s_3+c_3 d_4) (a_3 c_{\text{2+3}}-d_4 s_{\text{2+3}}+a_2 c_2)=0
\label{eqn:Sing}
\end{equation}\end{center}

Thus, a singular configuration will be present every time one of the conditions in \autoref{eqn:singcases} is fulfilled. This will be taken into consideration while computing the inverse kinematics.

\begin{equation}
\begin{cases}
 a_2=0\\
 s_5=0\\
 a_3 s_3+c_3 d_4=0\\
 a_3 c_{\text{2+3}}-d_4 s_{\text{2+3}}+a_2 c_2=0\\
\end{cases}
\label{eqn:singcases}
\end{equation}
